#Copyright 2009 Daniel Monedero Tortola faltantornillos at gmail.com

#This file is part of Bright Player 0.2.

#    Bright Player 0.2 is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    Bright Player 0.2 is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

import gtk
import os
from signal import signal, SIGTERM
from sys import exit
import atexit

#Settings:
pathOff='/root/musicOff/*.ogg'
pathOn='/root/musicOn/*.ogg'
#volume='value' where value=[0,127]
volumeHand='121'
volumeHead='115'

defaultBrightness='37'

#Code:
playing = 0
one=-1
two=-1
three=-1
four=-1

def cleanupFunc():
	global playing
	global defaultBrightness
	unlock()
	os.system('xset s on');
	if playing == 1:
		playing=0
		os.system('killall mplayer > /dev/null')
		os.system('amixer cset iface=MIXER,name=\'Amp Spk Switch\' on > /dev/null')
		os.system('killall python /usr/bin/detector.py > /dev/null 2> /dev/null')

def exitFunc(target):
	exit(0)

def volume (target, value): 
	os.system ('amixer sset \'Headphone\' '+value+' > /dev/null &');

def lock(target):
	os.system('echo 1 > /sys/devices/platform/s3c2440-i2c/i2c-adapter/i2c-0/0-0073/backlight/pcf50633-bl/bl_power');
	w.fullscreen()
	hBoxOff.hide()
	hBoxOn.hide()
	hBoxVol.hide()
	hBoxExitLock.hide()
	lockUpBox.show()
	lockDownBox.show()

def unlock():
	os.system('echo 0 > /sys/devices/platform/s3c2440-i2c/i2c-adapter/i2c-0/0-0073/backlight/pcf50633-bl/bl_power')
	os.system('echo '+defaultBrightness+' > /sys/class/backlight/pcf50633-bl/brightness')
	w.unfullscreen()
	#os.system('echo '+defaultBrightness+' > /sys/class/backlight/gta02-bl/brightness')
	hBoxOff.hide()
	hBoxOn.hide()
	lockUpBox.hide()
	lockDownBox.hide()
	hBoxExitLock.show()
	hBoxVol.show()

def onFocusOutFunc(sender, event):
	w.disconnect(focusOutId)
	exitFunc(0)


def playFunc(target, parameter):
	global playing
	global pathOff
	global pathOn
	global volumeHand
	global volumeHead
	os.system('echo 1 > /sys/devices/platform/s3c2440-i2c/i2c-adapter/i2c-0/0-0073/backlight/pcf50633-bl/bl_power');
	os.system('xset s off');
	if playing == 0:
		playing = 1
		lock(0)
		if parameter == 'handOn' or parameter == 'handOff':
			os.system('amixer cset iface=MIXER,name=\'Headphone Playback Volume\' '+volumeHand+' '+volumeHand+' > /dev/null')
		else:
			os.system('amixer cset iface=MIXER,name=\'Amp Spk Switch\' off > /dev/null')
			os.system('amixer cset iface=MIXER,name=\'Headphone Playback Volume\' '+volumeHead+' '+volumeHead+' > /dev/null')
		#os.system('nice --15 mplayer -really-quiet -noconsolecontrols -nojoystick -nolirc -nomouseinput -shuffle '+path+' > /dev/null &')
		if parameter == 'handOff' or parameter == 'headOff':
			os.system('mplayer -really-quiet -noconsolecontrols -nojoystick -nolirc -nomouseinput -shuffle '+pathOff+' > /dev/null &')
		else:
			os.system('mplayer -really-quiet -noconsolecontrols -nojoystick -nolirc -nomouseinput -shuffle '+pathOn+' > /dev/null &')
		os.system("rm .pid")
		os.system("pidof mplayer > .pid")
		temp_pidfile = open('.pid', 'r')
		temp_pid = temp_pidfile.readline()
		temp_pid = temp_pid.rstrip("\n")
		temp_pidfile.close()
		os.system("renice -15 " + str(temp_pid))
		focusOutId=w.connect('focus_out_event', onFocusOutFunc)
		os.system('python /usr/bin/detector.py > /dev/null &')

def oneFunc(target):
	global one
	global two
	global three
	global four
	one=1
	two=-1
	three=-1
	four=-1

def twoFunc(target):
	global one
	global two
	global three
	global four
	if one==1:
		two=1
	else:
		one=-1
		two=-1
		three=-1
		four=-1

def threeFunc(target):
	global one
	global two
	global three
	global four
	if two==1:
		three=1
	else:
		one=-1
		two=-1
		three=-1
		four=-1

def fourFunc(target):
	global one
	global two
	global three
	global four
	global defaultBrightness
	four*=-1
	if one==1 and two==1 and three==1 and four==1:
		temp_pidfile = open('.pid', 'r')
		temp_pid = temp_pidfile.readline()
		temp_pid = temp_pid.rstrip("\n")
		temp_pidfile.close()
		os.system("renice +0 " + str(temp_pid))
		unlock()
	else:
		one=-1
		two=-1
		three=-1
		four=-1

w = gtk.Window()

vBox = gtk.VBox()
hBoxExitLock = gtk.HBox()
hBoxVol = gtk.HBox()
hBoxOff = gtk.HBox()
hBoxOn = gtk.HBox()
lockUpBox = gtk.HBox()
lockDownBox = gtk.HBox()

exitButton = gtk.Button()
lockButton = gtk.Button()
bVolDown = gtk.Button()
bVolUp = gtk.Button()
handOffButton = gtk.Button()
headOffButton = gtk.Button()
handOnButton = gtk.Button()
headOnButton = gtk.Button()
oneButton = gtk.Button(label='1')
twoButton = gtk.Button(label='2')
threeButton = gtk.Button(label='3')
fourButton = gtk.Button(label='4')

exitImage = gtk.Image()
lockImage = gtk.Image()
handImage = gtk.Image()
headImage = gtk.Image()
handOnImage = gtk.Image()
headOnImage = gtk.Image()
volDownImage = gtk.Image()
volUpImage = gtk.Image()

atexit.register(cleanupFunc)
signal(SIGTERM, lambda signum, stack_frame: exit(0))

w.set_title('Bright Player')
w.set_icon_from_file('/usr/share/pixmaps/brightPlayer.png')

w.add(vBox)
hBoxExitLock.add(lockButton)
hBoxExitLock.add(exitButton)
hBoxOff.add(handOffButton)
hBoxOff.add(headOffButton)
hBoxOn.add(handOnButton)
hBoxOn.add(headOnButton)
hBoxVol.add(bVolDown)
hBoxVol.add(bVolUp)
lockUpBox.add(oneButton)
lockUpBox.add(fourButton)
lockDownBox.add(twoButton)
lockDownBox.add(threeButton)

vBox.add(hBoxExitLock)
vBox.add(hBoxVol)
vBox.add(hBoxOff)
vBox.add(hBoxOn)
vBox.add(lockUpBox)
vBox.add(lockDownBox)

exitImage.set_from_file('/usr/share/pixmaps/brightExit.png')
lockImage.set_from_file('/usr/share/pixmaps/brightLock.png')
handImage.set_from_file('/usr/share/pixmaps/brightHand.png')
headImage.set_from_file('/usr/share/pixmaps/brightHead.png')
handOnImage.set_from_file('/usr/share/pixmaps/brightHandOn.png')
headOnImage.set_from_file('/usr/share/pixmaps/brightHeadOn.png')
volDownImage.set_from_file('/usr/share/pixmaps/brightVolDown.png')
volUpImage.set_from_file('/usr/share/pixmaps/brightVolUp.png')

exitButton.set_image(exitImage)
lockButton.set_image(lockImage)
handOffButton.set_image(handImage)
headOffButton.set_image(headImage)
handOnButton.set_image(handOnImage)
headOnButton.set_image(headOnImage)
bVolDown.set_image(volDownImage)
bVolUp.set_image(volUpImage)

w.connect('destroy_event', exitFunc)

exitButton.connect('clicked', exitFunc)
lockButton.connect('clicked', lock)
handOffButton.connect('clicked', playFunc, 'handOff')
headOffButton.connect('clicked', playFunc, 'headOff')
handOnButton.connect('clicked', playFunc, 'handOn')
headOnButton.connect('clicked', playFunc, 'headOn')
bVolUp.connect('clicked', volume,"5+")
bVolDown.connect('clicked', volume,"5-")
oneButton.connect('clicked', oneFunc)
twoButton.connect('clicked', twoFunc)
threeButton.connect('clicked', threeFunc)
fourButton.connect('clicked', fourFunc)

w.show_all()

hBoxExitLock.hide()
hBoxVol.hide()
lockUpBox.hide()
lockDownBox.hide()

gtk.main()
